package es.ucm.fdi.grasia.faerie.demos.talkingAgents.app;

import java.net.URI;

import org.apache.felix.scr.annotations.Component;
import org.apache.log4j.Logger;

import es.ucm.fdi.grasia.faerie.core.AbstractContextObserverComponent;
import es.ucm.fdi.grasia.faerie.core.Attribute;
import es.ucm.fdi.grasia.faerie.core.ContextEvent;
import es.ucm.fdi.grasia.faerie.core.util.ContextURIs;
import es.ucm.fdi.grasia.faerie.demos.talkingAgents.model.MyLocation;
import es.ucm.fdi.grasia.faerie.model.base.Person;

/**
 *
 * @author Chema
 */
@Component(inherit = true)
@SuppressWarnings({ "unchecked", "rawtypes" })
public class Application extends AbstractContextObserverComponent {

	private Person anonPerson = null;

	@Override
	public void addMyReferencedEntities() {
		anonPerson = (Person) this.addReferencedEntity(new Person(ContextURIs.authorityURI(ContextURIs.localURI()), URI
				.create("/talkingAgents/"), URI.create("Mary")));
	}

	@Override
	public void activate() {
		super.activate();

		MyLocation location = new MyLocation(anonPerson);
		location = this.contextRequest(location);
		this.putObservedElement(location);

		Logger.getLogger(this.getClass()).info("Initial location: " + location);
	}

	@Override
	public void elementUpdated(Attribute attribute, ContextEvent event) {
		Logger.getLogger(this.getClass()).info("Location updated: " + attribute.getValue().getData());
	}
}
